#! /usr/bin/python2.7
# vim: fileencoding=utf-8 encoding=utf-8 et sw=4

import os
import sys
import math
import xml.etree.cElementTree as ElementTree
import codecs

miasto = sys.argv[1]

fns = []
for dirpath, dirnames, filenames in os.walk(miasto):
	fns = [ fn for fn in filenames if fn.startswith('addrfeat') ]
	break

addrs = {}
for fn in fns:
	f = open(miasto + '/' + fn)
	s = ''
	tags = {}
	for tag in f.read().split('<')[1:]:
		if tag.startswith('th ') or tag.startswith('td '):
			s = ''
		if tag.startswith('/th>'):
			k = s
		if tag.startswith('/td>'):
			tags[k] = s.strip().decode('utf-8')
		s += tag.split('>', 1)[1]
	f.close()

	key = tags['PUWG 1992']
	if key in addrs:
		print('dupe: ' + key)

	# Drop stuff in parenthesis
	for k in tags:
		if '(' in tags[k]:
			tags[k] = tags[k].split('(', 1)[0].strip()

	lon, lat = tags.pop('GPS (WGS 84)').split(', ')
	if lat[:2] != 'B ' or lon[:2] != 'L ':
		raise xyz
	lat = lat[2:]
	lon = lon[2:]
	float(lat)
	float(lon)

	# 'Data zmiany': '2012-07-31 13:20:10', 'Miejscowo\xc5\x9b\xc4\x87 (SIMC)': 'Sicko', 'PUWG 1992': 'Y 266334, X 605673', 'Numer': '4', 'Dzia\xc5\x82ka': '155/2', 'Nazwa ulicy (ULIC)': '', 'Obr\xc4\x99b': 'Sicko', 'Kod pocztowy': ''}

	osmtags = {}
	hn = tags['Numer'].lower()
	while hn[-1] == '?':
		hn = hn[:-1]
		osmtags['fixme'] = 'Adres do sprawdzenia'
	if 'bl' in hn:
		pos = hn.find('bl')
		pos2 = pos + 2
		while pos and hn[pos - 1] == ' ':
			pos -= 1
		while pos2 < len(hn) and hn[pos2] in '. ':
			pos2 += 1
		if pos2 < len(hn) and pos > 0:
			hn = hn[:pos] + '/' + hn[pos2:]
	osmtags['addr:housenumber'] = hn
	if tags['Nazwa ulicy(Id GUS)']:
		osmtags['addr:street'] = tags['Nazwa ulicy(Id GUS)']
		osmtags['addr:city'] = tags['Miejscowość(Id GUS)']
	else:
		osmtags['addr:place'] = tags['Miejscowość(Id GUS)']
		osmtags['addr:city'] = tags['Miejscowość(Id GUS)']
		#if tags['Obr\xc4\x99b']:
		#	osmtags['addr:city'] = tags['Obr\xc4\x99b']
	#osmtags['obreb'] = tags['Obr\xc4\x99b']
	if tags['Kod pocztowy']:
		osmtags['addr:postcode'] = tags['Kod pocztowy']

	addrs[key] = ( lat, lon, osmtags )

i = 1
root = ElementTree.Element('osm', { 'version': '0.6' })
for ak in addrs:
	lat, lon, tags = addrs[ak]
	node = ElementTree.SubElement(root, 'node', {
		'lat': lat, 'lon': lon,
		'version': str(1),
		'id': str(-i) })
	for k in tags:
		ElementTree.SubElement(node, 'tag', { 'k': k, 'v': tags[k] })
	i += 1
ElementTree.ElementTree(root).write(miasto + '.osm', 'utf-8')
