#! /sw/bin/python2.7
import PIL.Image as Image
import ImageDraw as ImageDraw
import os
import sys
import math
import xml.etree.cElementTree as ElementTree
import urllib
import codecs

miasto = sys.argv[1]

capsfile = miasto + '/wmscaps.xml'
root = ElementTree.parse(capsfile).getroot()
for n in root:
	if n.tag.endswith('}Capability'):
		node = n
		break
for n in node:
	if n.tag.endswith('}Layer'):
		node = n
		break
ext = {}
for n in node:
	if not n.tag.endswith('}Layer'):
		continue
	for sub in n:
		if sub.tag.endswith('}Name'):
			name = sub.text
		if sub.tag.endswith('}BoundingBox'):
			bb = ( float(sub.attrib['minx']),
				float(sub.attrib['miny']),
				float(sub.attrib['maxx']),
				float(sub.attrib['maxy']) )
	ext[name] = bb

bbox = ext['punkty']
resolution = 0.75 # m/px

curl = codecs.open(miasto + '/feats.curl', 'w', 'utf-8')
curl.write("compress\n")
fid = 0

tsize = ( 4096, 4096 )
maxx = int((bbox[2] - bbox[0]) / resolution / tsize[0]) + 1
maxy = int((bbox[3] - bbox[1]) / resolution / tsize[1]) + 1

def scan(data, bbox):
	global fid
	addrs = []
	cur = {}
	for y in range(0, tsize[1]):
		i = 0
		for x in range(0, tsize[0]):
			clr = data[x, y][0]
			if clr > 10:
				i = 0
				if x in cur:
					del cur[x]
				continue
			if i:
				continue
			i = 1
			found = 0
			for cx in cur:
				if x > cx - 3 and x < cx + 3:
					found = 1
					break
			if not found:
				cur[x] = 0
				addrs.append(( x + 1, y + 1 ))
	for x, y in addrs:
		url = 'http://www.punktyadresowe.pl/cgi-bin/mapserv?map=' + \
			'/home/www/impa2/wms/' + miasto + '.map&VERSION=' + \
			'1.1.1&SERVICE=WMS&REQUEST=GetFeatureInfo&' + \
			'QUERY_LAYERS=punkty&SRS=EPSG:2180&WIDTH=' + \
			str(tsize[0]) + '&HEIGHT=' + \
			str(tsize[1]) + '&BBOX=' + str(bbox[0]) + ',' + \
			str(bbox[1]) + ',' + str(bbox[2]) + ',' + \
			str(bbox[3]) + '&LAYERS=punkty&X=' + str(x) + \
			'&Y=' + str(y) + '&INFO_FORMAT=text/html'
		npath = miasto + '/addrfeat' + str(fid)
		if not os.path.exists(npath):
			curl.write('url = ' + url + '\n')
			curl.write('output = ' + npath + '\n\n')
		fid += 1

for x in range(0, maxx):
	for y in range(0, maxy):
#for x in range(2, 3):
#	for y in range(2, 3):
		x0 = bbox[0] + (x + 0) * resolution * tsize[0]
		y0 = bbox[1] + (y + 0) * resolution * tsize[1]
		x1 = bbox[0] + (x + 1) * resolution * tsize[0]
		y1 = bbox[1] + (y + 1) * resolution * tsize[1]
		fn = miasto + '/addrtile' + str(x) + '-' + str(y)
		#if os.path.getsize(fn) == 66371:
		if os.path.getsize(fn) == 58763:
			continue
		tile = Image.open(fn).convert("RGB")
		data = tile.load()
		scan(data, ( y0, x0, y1, x1 ))
		print(repr(( x, y )))

curl.close()
