#! /sw/bin/python2.7
import PIL.Image as Image
import ImageDraw as ImageDraw
import os
import sys
import math
import xml.etree.cElementTree as ElementTree
import urllib
import codecs

miasto = sys.argv[1]

capsfile = miasto + '/wmscaps.xml'
if not os.path.exists(capsfile):
	url = 'http://www.punktyadresowe.pl/cgi-bin/mapserv?map=/home/www/impa2/wms/' + miasto + '.map&REQUEST=GetCapabilities&SERVICE=WMS'
	os.mkdir(miasto)
	urllib.urlretrieve(url, miasto + '/wmscaps.xml')

root = ElementTree.parse(capsfile).getroot()
for n in root:
	if n.tag.endswith('}Capability'):
		node = n
		break
for n in node:
	if n.tag.endswith('}Layer'):
		node = n
		break
ext = {}
for n in node:
	if not n.tag.endswith('}Layer'):
		continue
	for sub in n:
		if sub.tag.endswith('}Name'):
			name = sub.text
		if sub.tag.endswith('}BoundingBox'):
			bb = ( float(sub.attrib['minx']),
				float(sub.attrib['miny']),
				float(sub.attrib['maxx']),
				float(sub.attrib['maxy']) )
	ext[name] = bb

bbox = ext['punkty']
resolution = 0.75 # m/px

curl = codecs.open(miasto + '/tiles.curl', 'w', 'utf-8')
curl.write("compress\n")

tsize = ( 4096, 4096 )
maxx = int((bbox[2] - bbox[0]) / resolution / tsize[0]) + 1
maxy = int((bbox[3] - bbox[1]) / resolution / tsize[1]) + 1
for x in range(0, maxx):
	for y in range(0, maxy):
		x0 = bbox[0] + (x + 0) * resolution * tsize[0]
		y0 = bbox[1] + (y + 0) * resolution * tsize[1]
		x1 = bbox[0] + (x + 1) * resolution * tsize[0]
		y1 = bbox[1] + (y + 1) * resolution * tsize[1]
		url = 'http://www.punktyadresowe.pl/cgi-bin/mapserv?map=' + \
			'/home/www/impa2/wms/' + miasto + '.map&FORMAT=' + \
			'image/png&VERSION=1.1.0&SERVICE=WMS&REQUEST=GetMap' + \
			'&LAYERS=punkty&STYLES=&SRS=EPSG:2180' + \
			'&WIDTH=' + str(tsize[0]) + \
			'&HEIGHT=' + str(tsize[1]) + \
			'&BBOX=' + str(y0) + ',' + str(x0) + ',' + \
			str(y1) + ',' + str(x1)
		curl.write('url = ' + url + '\n')
		curl.write('output = ' + miasto + '/addrtile' +
			str(x) + '-' + str(y) + '\n\n')

curl.close()
